using System;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using MeshVR;
using SimpleJSON;
using MacGruber;
using MVR.FileManagementSecure;


namespace CheesyFX {
	public partial class CheesyFX_WorkOut : MVRScript {
        
        

        public void CreateUI(){
            UIDynamicButton button;
            UIDynamicSlider slider;

            button = Utils.SetupButton(this, "Save", UISaveJSONDialog, false);
            button = Utils.SetupButton(this, "Load",  delegate {}, true);
            
            loadURL.RegisterFileBrowseButton(button.button);

            FloatDriver fd = textureManager.drivers[0];
            slider = CreateSlider(fd.maxGloss, false);
            slider = CreateSlider(fd.minGloss, false);
            slider = CreateSlider(fd.highTreshold, false);
            slider = CreateSlider(fd.idleThreshold, false);
            slider = CreateSlider(fd.timeEffect, false);

            button = Utils.SetupButton(this, "Set to default", textureManager.drivers[0].SetToDefault, false);

            Utils.SetupInfoText(this, "Maximal gloss value achievable.", 120f, true);
            Utils.SetupInfoText(this, "Minimal gloss value achievable", 120f, true);
            Utils.SetupInfoText(this, "Activeness, which must be obtained to not decrease the gloss value at the maxGloss value.", 120f, true);
            Utils.SetupInfoText(this, "Activeness, which is considered idle at the minGloss value, so that the gloss value does not increase.", 120f, true);
            Utils.SetupInfoText(this, "Prolonged workouts produce more sweat, even at the same level of activeness. This gradually reduces the highIdleThreshold to 2*lowIdleThreshold and all values in between, while the workout continues. Disrupting the workout (activeness below the current threshold) will reduce the effect faster than it builds up, since regeneration typically takes less time then exhaustion. Set to 0 to disable.", 400f, true);
            Utils.SetupInfoText(this, "Core info:\nThe activeness of the containing Person is calculated by the sum over the translational and rotational accelerations of the relevant rigidbodies times their respective mass (which equals their forces, since F=ma). The source of the force is not relevant at the moment. It can be pushed or push itsef, which is difficult to programatically dstinguish. Use timeline, cycleforces or wiggle the controllers, it doesn't matter.\nThere is an internal growth threshold between lowIdleThreshold and highIdleThreshold, which must be achieved to buid up sweat. Otherwise it decreses to minGloss. This threshold increases with the current gloss value. The more you overshoot this threshold, the faster the sweat builds up, or otherwise. In addition to that, a surplus of say 1 produces less additional sweat at higher gloss values, since sweat evaporates faster, the hotter you are. Over time, the threshold decreases as you work out, since you get exhausted. This means that a workout with a given intensity settles at a specific gloss level at first, but this level increases slowly. The timeEffect manages this behaviour.", 500f, false);
        
            slider = CreateSlider(fd.currentRate, true);

        }

        
    }
}